//
//  test48.cpp
//  Lecture3CPP
//
//  Created by presentations on 12/4/17.
//
//

/* Demonstration of rethrowing an exception  */
#include <iostream>
#include <exception>
using namespace std; // includes std::exception.

void throwException()
{
    // Throw an exception and immediately catch it.
    try {
        cout << "Function throwException\n";
        throw exception();  // generate exception
    } // end try
    catch( exception e )
    {
        cout << "Exception handled in function throwException\n";
        throw;  // rethrow exception for further processing
    } // end catch
    
    cout << "This also should not print\n";
} // end function throwException



int main()
{
    try {
        throwException();
        cout << "This should not print\n";
    } // end try
    catch ( exception e )
    {
        cout << "Exception handled in main\n";
    } // end catch
    
    cout << "Program control continues after catch in main"
    << endl;
    return 0;
} // end function main
