//
//  testStack.cpp
//  Lecture3CPP
//
//  Created by presentations on 12/4/17.
//
//

#include <iostream>
using namespace std;
#include "tstack.h"

int main()
{
    Stack< double > doubleStack( 5 );
    double f = 1.1;
    
    cout << "Pushing elements onto doubleStack\n";
    while ( doubleStack.push( f ) ) { // success true returned
        cout << f << ' ';
        f += 1.1;
    } // end while
    
    cout << "\nStack is full. Cannot push " << f
    << "\n\nPopping elements from doubleStack\n";
    
    while ( doubleStack.pop( f ) )  // success true returned
        cout << f << ' ';
    
    cout << "\nStack is empty. Cannot pop\n";
    
    Stack< int > intStack;
    int i = 1;
    cout << "\nPushing elements onto intStack\n";
    while ( intStack.push( i ) ) { // success true returned
        cout << i << ' ';
        ++i;
    } // end while
    
    cout << "\nStack is full. Cannot push " << i
    << "\n\nPopping elements from intStack\n";
    
    while ( intStack.pop( i ) )  // success true returned
        cout << i << ' ';
    cout << "\nStack is empty. Cannot pop\n";
    
    return 0;
} // end function main
